<?php

namespace SchommerMedia\SmediaCourse\Controller;

/***
 *
 * This file is part of the "Kurs" Extension for TYPO3 CMS.
 *
 *
 * (c) Changes by Stefan Bublies@dt-internet.de, 2020
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2018
 *
 ***/

use TYPO3\CMS\Core\Page\PageRenderer;
use TYPO3\CMS\Core\Utility\ExtensionManagementUtility;
use TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * CourseController
 */
class CourseController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{
    /**
     * Init
     *
     * @return void
     */
    protected function initializeAction() {

        parent::initializeAction();
        $siteRelPath = ExtensionManagementUtility::siteRelPath($this->request->getControllerExtensionKey());
        $pageRenderer = GeneralUtility::makeInstance(PageRenderer::class);
        $pageRenderer->addCssFile($siteRelPath.'Resources/Public/Stylesheets/style.min.css');

    }


    /**
     * action list
     *
     * @return void
     */
    public function listAction()
    {
        $licence = $this->settings['licenceNr'];
        $coursetyp = $this->settings['courseTyp'];
        $coursePlace = trim($this->settings['coursePlace']);
        $design = $this->settings['design'];
		$last5 = $this->settings['last5'];
		$navigation = $this->settings['navigation'];

        $urldesign = "&NOHEADER=J&t3plugin=J";

        if ($design == 1) {
            $urldesign.= "&TYPO3=J";
        }

        if ($last5 == 1) {
            $urldesign.= "&top5=J";
        }

        if ($coursePlace != "") {
            $urldesign.= "&Ort=" . $coursePlace;
        }

        if ($navigation == 1) {
            $urldesign.= "&T3Nav=J";
        }

        $protocol = "https://";

        if ($coursetyp != "") {
            $url = $protocol . "www.kurs-anmeldung.de/go.dll?Lic=" . $licence . "&KursTyp=" . $coursetyp;
        } else {
            $url = $protocol . "www.kurs-anmeldung.de/go.dll?Lic=" . $licence;
        }

        $url = $url . $urldesign;

        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
        $content = curl_exec($ch);
        curl_close($ch);
        $this->view->assign('course', $content);

    }
}
