<?php
namespace SchommerMedia\SmediaCourse\Tests\Unit\Controller;

/**
 * Test case.
 */
class CourseControllerTest extends \TYPO3\CMS\Core\Tests\UnitTestCase
{
    /**
     * @var \SchommerMedia\SmediaCourse\Controller\CourseController
     */
    protected $subject = null;

    protected function setUp()
    {
        parent::setUp();
        $this->subject = $this->getMockBuilder(\SchommerMedia\SmediaCourse\Controller\CourseController::class)
            ->setMethods(['redirect', 'forward', 'addFlashMessage'])
            ->disableOriginalConstructor()
            ->getMock();
    }

    protected function tearDown()
    {
        parent::tearDown();
    }

    /**
     * @test
     */
    public function listActionFetchesAllCoursesFromRepositoryAndAssignsThemToView()
    {

        $allCourses = $this->getMockBuilder(\TYPO3\CMS\Extbase\Persistence\ObjectStorage::class)
            ->disableOriginalConstructor()
            ->getMock();

        $courseRepository = $this->getMockBuilder(\::class)
            ->setMethods(['findAll'])
            ->disableOriginalConstructor()
            ->getMock();
        $courseRepository->expects(self::once())->method('findAll')->will(self::returnValue($allCourses));
        $this->inject($this->subject, 'courseRepository', $courseRepository);

        $view = $this->getMockBuilder(\TYPO3\CMS\Extbase\Mvc\View\ViewInterface::class)->getMock();
        $view->expects(self::once())->method('assign')->with('courses', $allCourses);
        $this->inject($this->subject, 'view', $view);

        $this->subject->listAction();
    }
}
